.include "gameman.h.s"

playing: .db #1
score: .dw #0x0000
str_game_over: .asciz "Game Over"
str_pressR: .asciz "Press R"
double_score_time: .db #0
high_score: .dw #0x0000

active_double_score:
    ld a, #max_time_double_score
    ld (double_score_time), a
ret

;;ENTRADA:  bc -> puntuacion a sumar
add_score:
    ld a,(num_level)
    ld e,a
    inc e ;;Para evitar multiplicaciones por 0

    ld a,(double_score_time)
    and a
    jr z,no_double_score

    ;;a = multiplicador puntuacion
    ld a,#2
    jr add_more_score

    no_double_score:
    ld a,#1

    add_more_score:
        push af
        ld a,(num_level)
        ld e,a
        inc e
        ld hl,(score)
        suma_punt:
            add hl,bc
            ld a,l
            daa
            ld l,a
            jr nc,no_carry_score
            ;;Si hay carry sumamos 1 a h
            ld a,h
            add a,#01
            daa
            ld h,a

            no_carry_score:
            dec e
        jr nz, suma_punt

        ld (score),hl
        pop af
        dec a
    jr nz, add_more_score

    ld hl,(score)
    ld bc,(high_score)
    
    ld a,l
    sub a,c
    jr nc,sigue_rest

    inc b
    
    sigue_rest:
    ld a,h
    sub a,b
    ret m

    ld hl,(score)
    ld (high_score),hl

ret

game_over:
    ld a,#0
    ld (playing),a
ret

restart:
    ld a,#1
    ld (playing),a

    call entityman_resetEntities
    call clean_screen
    ld hl,#0
    ld (score),hl

    call restart_lifes
    
ret